/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/

#include "stdafx.h"
#include "WMTop10.h"
#include "CPluginWindow.h"

void CWMTop10::OpenStateChange( long NewState )
{
    switch (NewState)
    {
    case wmposUndefined:
        break;
	case wmposPlaylistChanging:
        break;
	case wmposPlaylistLocating:
        break;
	case wmposPlaylistConnecting:
        break;
	case wmposPlaylistLoading:
        break;
	case wmposPlaylistOpening:
        break;
	case wmposPlaylistOpenNoMedia:
        break;
	case wmposPlaylistChanged:
        break;
	case wmposMediaChanging:
        break;
	case wmposMediaLocating:
        break;
	case wmposMediaConnecting:
        break;
	case wmposMediaLoading:
        break;
	case wmposMediaOpening:
        break;
	case wmposMediaOpen:
		m_pPluginWindow->RedrawWindow();
        break;
	case wmposBeginCodecAcquisition:
        break;
	case wmposEndCodecAcquisition:
        break;
	case wmposBeginLicenseAcquisition:
        break;
	case wmposEndLicenseAcquisition:
        break;
	case wmposBeginIndividualization:
        break;
	case wmposEndIndividualization:
        break;
	case wmposMediaWaiting:
        break;
	case wmposOpeningUnknownURL:
        break;
    default:
        break;
    }
}

void CWMTop10::PlayStateChange( long NewState )
{
    switch (NewState)
    {
    case wmppsUndefined:
        break;
	case wmppsStopped:
        break;
	case wmppsPaused:
        break;
	case wmppsPlaying:
        break;
	case wmppsScanForward:
        break;
	case wmppsScanReverse:
        break;
	case wmppsBuffering:
        break;
	case wmppsWaiting:
        break;
	case wmppsMediaEnded:
		m_pPluginWindow->RedrawWindow();
        break;
	case wmppsTransitioning:
        break;
	case wmppsReady:
        break;
	case wmppsReconnecting:
        break;
	case wmppsLast:
        break;
    default:
        break;
    }
}

void CWMTop10::AudioLanguageChange( long LangID )
{
}

void CWMTop10::StatusChange()
{
}

void CWMTop10::ScriptCommand( BSTR scType, BSTR Param )
{
}

void CWMTop10::NewStream()
{
}

void CWMTop10::Disconnect( long Result )
{
}

void CWMTop10::Buffering( VARIANT_BOOL Start )
{
}

void CWMTop10::Error()
{
    CComPtr<IWMPError>      spError;
    CComPtr<IWMPErrorItem>  spErrorItem;
    HRESULT                 dwError = S_OK;
    HRESULT                 hr = S_OK;

    if (m_spCore)
    {
        hr = m_spCore->get_error(&spError);

        if (SUCCEEDED(hr))
        {
            hr = spError->get_item(0, &spErrorItem);
        }

        if (SUCCEEDED(hr))
        {
            hr = spErrorItem->get_errorCode( (long *) &dwError );
        }
    }
}

void CWMTop10::Warning( long WarningType, long Param, BSTR Description )
{
}

void CWMTop10::EndOfStream( long Result )
{
}

void CWMTop10::PositionChange( double oldPosition, double newPosition)
{
}

void CWMTop10::MarkerHit( long MarkerNum )
{
}

void CWMTop10::DurationUnitChange( long NewDurationUnit )
{
}

void CWMTop10::CdromMediaChange( long CdromNum )
{
}

void CWMTop10::PlaylistChange( IDispatch * Playlist, WMPPlaylistChangeEventType change )
{
    switch (change)
    {
    case wmplcUnknown:
        break;
	case wmplcClear:
        break;
	case wmplcInfoChange:
        break;
	case wmplcMove:
        break;
	case wmplcDelete:
        break;
	case wmplcInsert:
        break;
	case wmplcAppend:
        break;
	case wmplcPrivate:
        break;
	case wmplcNameChange:
        break;
	case wmplcMorph:
        break;
	case wmplcSort:
        break;
	case wmplcLast:
        break;
    default:
        break;
    }
}

void CWMTop10::CurrentPlaylistChange( WMPPlaylistChangeEventType change )
{
    switch (change)
    {
    case wmplcUnknown:
        break;
	case wmplcClear:
        break;
	case wmplcInfoChange:
        break;
	case wmplcMove:
        break;
	case wmplcDelete:
        break;
	case wmplcInsert:
        break;
	case wmplcAppend:
        break;
	case wmplcPrivate:
        break;
	case wmplcNameChange:
        break;
	case wmplcMorph:
        break;
	case wmplcSort:
        break;
	case wmplcLast:
        break;
    default:
        break;
    }
}

void CWMTop10::CurrentPlaylistItemAvailable( BSTR bstrItemName )
{
}

void CWMTop10::MediaChange( IDispatch * Item )
{
}

void CWMTop10::CurrentMediaItemAvailable( BSTR bstrItemName )
{
}

void CWMTop10::CurrentItemChange( IDispatch *pdispMedia)
{
}

void CWMTop10::MediaCollectionChange()
{
}

void CWMTop10::MediaCollectionAttributeStringAdded( BSTR bstrAttribName,  BSTR bstrAttribVal )
{
}

void CWMTop10::MediaCollectionAttributeStringRemoved( BSTR bstrAttribName,  BSTR bstrAttribVal )
{
}

void CWMTop10::MediaCollectionAttributeStringChanged( BSTR bstrAttribName, BSTR bstrOldAttribVal, BSTR bstrNewAttribVal)
{
}

void CWMTop10::PlaylistCollectionChange()
{
}

void CWMTop10::PlaylistCollectionPlaylistAdded( BSTR bstrPlaylistName)
{
}

void CWMTop10::PlaylistCollectionPlaylistRemoved( BSTR bstrPlaylistName)
{
}

void CWMTop10::PlaylistCollectionPlaylistSetAsDeleted( BSTR bstrPlaylistName, VARIANT_BOOL varfIsDeleted)
{
}

void CWMTop10::ModeChange( BSTR ModeName, VARIANT_BOOL NewValue)
{
}

void CWMTop10::MediaError( IDispatch * pMediaObject)
{
}

void CWMTop10::OpenPlaylistSwitch( IDispatch *pItem )
{
}

void CWMTop10::DomainChange( BSTR strDomain)
{
}

void CWMTop10::SwitchedToPlayerApplication()
{
}

void CWMTop10::SwitchedToControl()
{
}

void CWMTop10::PlayerDockedStateChange()
{
}

void CWMTop10::PlayerReconnect()
{
}

void CWMTop10::Click( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10::DoubleClick( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10::KeyDown( short nKeyCode, short nShiftState )
{
}

void CWMTop10::KeyPress( short nKeyAscii )
{
}

void CWMTop10::KeyUp( short nKeyCode, short nShiftState )
{
}

void CWMTop10::MouseDown( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10::MouseMove( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10::MouseUp( short nButton, short nShiftState, long fX, long fY )
{
}
