/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/
#include "StdAfx.h"
#include "OrderedList.h"

COrderedList::COrderedList(void)
:m_nCapacity(10)
{
}

COrderedList::~COrderedList(void)
{
}

// Adds the pair to the ordered list, if it will fit. Returns the index, or -1 if not added
int COrderedList::Add(const CValueCountPair& pair)
{
	unsigned int nMax = Capacity();
	unsigned int nSize = NumItems();
	unsigned int i = 0;
	vector<CValueCountPair>::iterator iter = m_list.begin();
	while (i < nMax)
	{
		if (i >= nSize)
		{
			m_list.insert(iter, pair);
			return i;
		}
		else
		{
			CValueCountPair& current = m_list.at(i);
			if (pair.Count() > current.Count())
			{
				//insert new value
				iter = m_list.insert(iter, pair);
				//remove anything after this that has same name
				if (iter < m_list.end())
					iter++;
				while (iter < m_list.end())
				{
					if (pair.Value() == iter->Value())
					{
						m_list.erase(iter);
						return i;
					}
					iter++;
					
				}
				//remove everything afer nMax
				if (m_list.size() > nMax)
				{
					m_list.pop_back();					
				}
				return i;
			}
		}
		iter++;
		i++;
	}
	return -1;
}

// Removes all items from list
void COrderedList::Clear(void)
{
	m_list.clear();
}

CValueCountPair& COrderedList::GetAt(unsigned int nIndex)
{
	if (nIndex>=0 && nIndex < m_list.size())
	{
		return m_list.at(nIndex);
	}
	else
	{
		_ASSERT(0);
		return m_list.at(0);
	}
}

const CValueCountPair& COrderedList::GetAt(unsigned int nIndex) const
{
		if (nIndex>=0 && nIndex < m_list.size())
	{
		return m_list.at(nIndex);
	}
	else
	{
		_ASSERT(0);
		return m_list.at(0);
	}
}
