/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/
#pragma once

#include <vector>
#include "ValueCountPair.h"

using namespace std;


class COrderedList
{
public:
	COrderedList(void);
	virtual ~COrderedList(void);

	int Add(const CValueCountPair& pair);

	CValueCountPair& GetAt(unsigned int nIndex);
	const CValueCountPair& GetAt(unsigned int nIndex) const;
	void Clear(void);

	inline int NumItems(void) const { return (int)m_list.size();}
	inline int Capacity() const { return m_nCapacity; }
	inline void Capacity(int nCapacity) { m_nCapacity = nCapacity; }

private:
	vector<CValueCountPair> m_list;
	int m_nCapacity;

	
};
