/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/
#pragma once
#include "const.h"

class CSharedTop10List
{
public:
	CSharedTop10List(bool bReadOnly);
	~CSharedTop10List(void);

	//functions to query list
	inline int GetNumCategories() const { return m_pBase->nNumCategories; }
	inline int GetNumValues() const { return m_pBase->nNumValues; }
	inline int GetFieldLength() const { return m_pBase->nFieldLength; }
	LPCTSTR GetCategoryName(SongAttribute nCategory) const;
	LPCTSTR GetValueName(SongAttribute nCategory, int nIndex) const;
	int GetValueCount(SongAttribute nCategory, int nIndex) const;
	//functions to update list
	void UpdateEntry(SongAttribute nCategory, int nIndex, int nCount, const CString& strValue);
	void UpdateCategoryName(SongAttribute nCategory, const CString& strName);
	void Clear();
private:
	void CreateSharedMemory(void);
	void DestroySharedMemory(void);

	
private:
	HANDLE m_hFile;
	TOP10STRUCT* m_pBase;
	bool m_bReadOnly;
	LPCTSTR m_szMapName;

};
