/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/
#pragma once

class CValueCountPair
{
public:
	CValueCountPair(void);
	CValueCountPair(const CString& rValue, int nCount);
	CValueCountPair(const CValueCountPair& rOther);
	~CValueCountPair(void);

	inline const CString& Value() const { return m_strValue; }
	inline CString& Value() { return m_strValue; }
	inline void Value(const CString& rValue) { m_strValue = rValue;}

	inline int Count() const { return m_nCount; }
	inline void Count(int nCount) { m_nCount = nCount; }

	CValueCountPair& operator=(const CValueCountPair& rOther) ;

private:
	CString m_strValue;
	int m_nCount;
};
