/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/
#include "StdAfx.h"
#include "ValueCounts.h"

void CValueCountsIterator::First()
{
	m_bReset = true;
}

bool CValueCountsIterator::Next(CValueCountPair& rPair)
{
	if (m_bReset)
	{
		m_bReset= false;
		m_iter = m_rMap.begin();
		
		if (m_iter!=m_rMap.end())
		{
			rPair = m_iter->second;
			return true;
		}
	}
	else if (m_iter!=m_rMap.end())
	{
		m_iter++;
		if (m_iter!=m_rMap.end())
		{
			rPair = m_iter->second;
			return true;
		}

	}
	return false;
}

CValueCounts::CValueCounts(void)
{
	
}

CValueCounts::~CValueCounts(void)
{
}

const CValueCountPair& CValueCounts::AddValue(const CString& rValue)
{
	ValueCountMapIterator iter = m_map.find(rValue);
	
	if (iter==m_map.end())
	{
		//create a new pair
		CValueCountPair pair(rValue, 1);
		m_map[rValue] = pair;
		iter = m_map.find(rValue);
		_ASSERT(iter!=m_map.end());
	}
	else
	{
		iter->second.Count(iter->second.Count()+1);
	}

	//return the found object
	return iter->second;	
}

void CValueCounts::AddValue(const CValueCountPair& rValueCounts)
{
	m_map[rValueCounts.Value()] = rValueCounts;
}

void CValueCounts::Clear()
{
	m_map.clear();
}