/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/

#include "stdafx.h"
#include "WMTop10Server.h"

void CWMTop10Server::OpenStateChange( long NewState )
{
    switch (NewState)
    {
    case wmposUndefined:
        break;
	case wmposPlaylistChanging:
        break;
	case wmposPlaylistLocating:
        break;
	case wmposPlaylistConnecting:
        break;
	case wmposPlaylistLoading:
        break;
	case wmposPlaylistOpening:
        break;
	case wmposPlaylistOpenNoMedia:
        break;
	case wmposPlaylistChanged:
        break;
	case wmposMediaChanging:
        break;
	case wmposMediaLocating:
        break;
	case wmposMediaConnecting:
        break;
	case wmposMediaLoading:
        break;
	case wmposMediaOpening:
        break;
	case wmposMediaOpen:
		if (settings.nRecordSignal==rssSongStart)
		{
			AddCurrentSong();
		}
        break;
	case wmposBeginCodecAcquisition:
        break;
	case wmposEndCodecAcquisition:
        break;
	case wmposBeginLicenseAcquisition:
        break;
	case wmposEndLicenseAcquisition:
        break;
	case wmposBeginIndividualization:
        break;
	case wmposEndIndividualization:
        break;
	case wmposMediaWaiting:
        break;
	case wmposOpeningUnknownURL:
        break;
    default:
        break;
    }
}

void CWMTop10Server::PlayStateChange( long NewState )
{
    switch (NewState)
    {
    case wmppsUndefined:
        break;
	case wmppsStopped:
        break;
	case wmppsPaused:
        break;
	case wmppsPlaying:
        break;
	case wmppsScanForward:
        break;
	case wmppsScanReverse:
        break;
	case wmppsBuffering:
        break;
	case wmppsWaiting:
        break;
	case wmppsMediaEnded:
		if (settings.nRecordSignal==rssSongEnd)
		{
			AddCurrentSong();
		}
        break;
	case wmppsTransitioning:
        break;
	case wmppsReady:
        break;
	case wmppsReconnecting:
        break;
	case wmppsLast:
        break;
    default:
        break;
    }
}

void CWMTop10Server::AudioLanguageChange( long LangID )
{
}

void CWMTop10Server::StatusChange()
{
}

void CWMTop10Server::ScriptCommand( BSTR scType, BSTR Param )
{
}

void CWMTop10Server::NewStream()
{
}

void CWMTop10Server::Disconnect( long Result )
{
}

void CWMTop10Server::Buffering( VARIANT_BOOL Start )
{
}

void CWMTop10Server::Error()
{
    CComPtr<IWMPError>      spError;
    CComPtr<IWMPErrorItem>  spErrorItem;
    HRESULT                 dwError = S_OK;
    HRESULT                 hr = S_OK;

    if (m_spCore)
    {
        hr = m_spCore->get_error(&spError);

        if (SUCCEEDED(hr))
        {
            hr = spError->get_item(0, &spErrorItem);
        }

        if (SUCCEEDED(hr))
        {
            hr = spErrorItem->get_errorCode( (long *) &dwError );
        }
    }
}

void CWMTop10Server::Warning( long WarningType, long Param, BSTR Description )
{
}

void CWMTop10Server::EndOfStream( long Result )
{
}

void CWMTop10Server::PositionChange( double oldPosition, double newPosition)
{
}

void CWMTop10Server::MarkerHit( long MarkerNum )
{
}

void CWMTop10Server::DurationUnitChange( long NewDurationUnit )
{
}

void CWMTop10Server::CdromMediaChange( long CdromNum )
{
}

void CWMTop10Server::PlaylistChange( IDispatch * Playlist, WMPPlaylistChangeEventType change )
{
    switch (change)
    {
    case wmplcUnknown:
        break;
	case wmplcClear:
        break;
	case wmplcInfoChange:
        break;
	case wmplcMove:
        break;
	case wmplcDelete:
        break;
	case wmplcInsert:
        break;
	case wmplcAppend:
        break;
	case wmplcPrivate:
        break;
	case wmplcNameChange:
        break;
	case wmplcMorph:
        break;
	case wmplcSort:
        break;
	case wmplcLast:
        break;
    default:
        break;
    }
}

void CWMTop10Server::CurrentPlaylistChange( WMPPlaylistChangeEventType change )
{
    switch (change)
    {
    case wmplcUnknown:
        break;
	case wmplcClear:
        break;
	case wmplcInfoChange:
        break;
	case wmplcMove:
        break;
	case wmplcDelete:
        break;
	case wmplcInsert:
        break;
	case wmplcAppend:
        break;
	case wmplcPrivate:
        break;
	case wmplcNameChange:
        break;
	case wmplcMorph:
        break;
	case wmplcSort:
        break;
	case wmplcLast:
        break;
    default:
        break;
    }
}

void CWMTop10Server::CurrentPlaylistItemAvailable( BSTR bstrItemName )
{
}

void CWMTop10Server::MediaChange( IDispatch * Item )
{
}

void CWMTop10Server::CurrentMediaItemAvailable( BSTR bstrItemName )
{
}

void CWMTop10Server::CurrentItemChange( IDispatch *pdispMedia)
{
}

void CWMTop10Server::MediaCollectionChange()
{
}

void CWMTop10Server::MediaCollectionAttributeStringAdded( BSTR bstrAttribName,  BSTR bstrAttribVal )
{
}

void CWMTop10Server::MediaCollectionAttributeStringRemoved( BSTR bstrAttribName,  BSTR bstrAttribVal )
{
}

void CWMTop10Server::MediaCollectionAttributeStringChanged( BSTR bstrAttribName, BSTR bstrOldAttribVal, BSTR bstrNewAttribVal)
{
}

void CWMTop10Server::PlaylistCollectionChange()
{
}

void CWMTop10Server::PlaylistCollectionPlaylistAdded( BSTR bstrPlaylistName)
{
}

void CWMTop10Server::PlaylistCollectionPlaylistRemoved( BSTR bstrPlaylistName)
{
}

void CWMTop10Server::PlaylistCollectionPlaylistSetAsDeleted( BSTR bstrPlaylistName, VARIANT_BOOL varfIsDeleted)
{
}

void CWMTop10Server::ModeChange( BSTR ModeName, VARIANT_BOOL NewValue)
{
}

void CWMTop10Server::MediaError( IDispatch * pMediaObject)
{
}

void CWMTop10Server::OpenPlaylistSwitch( IDispatch *pItem )
{
}

void CWMTop10Server::DomainChange( BSTR strDomain)
{
}

void CWMTop10Server::SwitchedToPlayerApplication()
{
}

void CWMTop10Server::SwitchedToControl()
{
}

void CWMTop10Server::PlayerDockedStateChange()
{
}

void CWMTop10Server::PlayerReconnect()
{
}

void CWMTop10Server::Click( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10Server::DoubleClick( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10Server::KeyDown( short nKeyCode, short nShiftState )
{
}

void CWMTop10Server::KeyPress( short nKeyAscii )
{
}

void CWMTop10Server::KeyUp( short nKeyCode, short nShiftState )
{
}

void CWMTop10Server::MouseDown( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10Server::MouseMove( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMTop10Server::MouseUp( short nButton, short nShiftState, long fX, long fY )
{
}
