/*
http://www.philosophicalgeek.com/software/windows-media-top-10-plug-in/
Copyright (c) 2007 Ben Watson (http://www.philosophicalgeek.com)

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this software.

Permission is granted to anyone to use this software for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
not claim that you wrote the original software. If you use this
software in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
distribution.
*/
#pragma once

typedef enum {
	saTitle = 0,
	saAlbumTitle,
	saAlbumArtist,
	saComposers,
	saArtists,
	saGenres,
	saLanguages,
	saNumSongAttributes
} SongAttribute;


const DWORD NUMCATEGORIES = saNumSongAttributes;
const DWORD NUMVALUES = 10;
const DWORD FIELDLENGTH = 40;

#pragma pack(push,1)

struct TOP10STRUCT {
	DWORD nNumCategories;
	DWORD nNumValues;
	DWORD nFieldLength;
	struct {
		TCHAR szCategoryName[FIELDLENGTH];
		struct 
		{
			TCHAR szValue[FIELDLENGTH];
			int nCount;
		} values[NUMVALUES];

	} categories[NUMCATEGORIES];
};
#pragma pack(pop)

//wait object names
const LPCTSTR gszServerMutexName = _T("WMTOP10_SERVER_MUTEX");
const LPCTSTR gszShutdownEventName = _T("WMTOP10_SHUTDOWN_EVENT");
const LPCTSTR gszRefreshEventName = _T("WMTOP10_REFRESH_EVENT");
const LPCTSTR gszServerShutdownEventName = _T("WMTOP10_SERVERSHUTDOWN_EVENT");
